# npm 工具使用
### 1. 创建一个账户

https://www.npmjs.com/

https://www.npmjs.com/~shenchunpeng

This is a quick way to get to your page in the future.
或者：

### 2. 安装npm并登录


npm install npm@latest -g

* 高级用户使用nvm
Using a Version Manager to install Node.js and npm

* 从终端登录
npm login

### 3. npm创建包，发布包，安装包
* 创建包
npm init
* 发布包
    - 第一次发布，需要使用npm adduser,默认登录了
    - 非第一次发布包，需要使用npm login
npm publish
* 安装包
    - 全局安装

    npm install -g 模块名称
    
    - 本地安装

    npm install 模块名称
    

    npm install 模块 --save 安装好后写入package.json的dependencies中（生产环境依赖）

    npm install 模块 --save-dev 安装好后写入package.json的devDepencies中（开发环境依赖）

* 删除包
   npm uninstall -g package利用npm删除全局模块

   npm uninstall 模块 //删除本地模块

* 撤销包
 npm unpublish 包名  -- force
> 只有在发包的24小时内才允许撤销发布的包（ unpublish is only allowed with versions published in the last 24 hours）即使你撤销了发布的包，发包的时候也不能再和被撤销的包的名称和版本重复了（即不能名称相同，版本相同，因为这两者构成的唯一标识已经被“占用”了）
替代（表明你的包已经不再维护了）：npm deprecate pkg

* npm的版本控制——Semantic versioning
    - 具体表现："version":"x.y.z"
    - 命令：npm version <update_type>自动改变版本，其中update_type为：patch, minor, or major


### 4.注意

* npm adduser终端添加账户后，并使用npm login也是可以的
* package.json:“name” 不能和别人的相同
*  package.json:name："author": "shenchunpeng"这个必须是你自己的

### 参考文献

https://www.cnblogs.com/penghuwan/p/6973702.html