# 第九章 玩转进程

### 进程事件

父进程能监听到与子进程相关的事件如下：
* error
* exit
* close
* disconnect

kill()并不能真正地将通过IPC相连的子进程杀死，它只是给子进程发送了一个系统信号，

SIGTERM：

* 对于回调函数中产生的异常，可以交给uncaughtException事件去捕获

* 进程中如果出现未能捕获的异常，就意味着有那么一段代码在健壮性上是不合格的。为此退出进程前，通过日志记录下问题所在是必须要做的事情，它可以帮我们很好地定位和追踪代码异常出现的位置。

```javascript
（1） 工作进程
process.on('uncaughtException', function (err) 
{
    // 记录日志记录
    logger.error(err);
    //发送自杀信号
    process.send({act: 'suicide'});
    //停止接受新的连接
    worker.close(function () {
// 所有已有连接断开后，退出进程
    process.exit(1);
});
// 5秒后退出进程
setTimeout(function () {
    process.exit(1);
    }, 5000);
});

（2） 父进程限量重启
//重启次数
var limit = 10;
//时间单位
var during =60000;
var restart = [];
var 
```