# 第四章 异步编程-事件发布/订阅模式

事件的处理方式正是基于高阶函数的特性来完成的

传递风格的程序编写将函数的业务重点从返回值转移到了回调函数。

child_process.fork()API可以利用多线程；

Built upon that same interface is the cluster module, which allows you to share sockets between processes to enable load balancing over your cores.

DEMO:

```javascript
// 订阅
var emitter = new events.EventEmitter();
emitter.on("event1", function (message) {
console.log(message);
});
// 发布
emitter.emit('event1', "I am message!");
```

### 1. 特点：

 （1）无须关注订阅的侦听器如何实现业务逻辑，甚至也不同关注多少个侦听器存在。
 ```javascript
 var emitter = new events.EventEmitter();
调用emitter.setMaxListeners(0)，可以去掉侦听器数量的限制
 ```
  
  (2) 事件的设计就是组件的接口设计

### 2. 继承events模块

```javaScript
var events = require('events');
function Stream() {
   events.EventEmitter.call(this);
}
util.inherits(Stream, events.EventEmitter);
```