# TLS
### 服务端

$ openssl genrsa -out ca.key 1024  //生成私钥
$ openssl req -new -key ca.key -out ca.csr  //生成CSR
$ openssl x509 -req -in ca.csr -signkey ca.key -out ca.crt //通过私钥自签名生成证书

//以下是想CA（Certificate Authority）机构申请证书的操作
$ openssl req -new -key server.key -out server.csr
$ openssl x509 -req -CA ca.crt -CAkey ca.key -CAcreateserial -in server.csr -out server.crt

var tls = require('tls');
var fs = require('fs');

### 客户端
// 创建私钥
$ openssl genrsa -out client.key 1024
// 生成CSR
$ openssl req -new -key client.key -out client.csr
// 生成书
$ openssl x509 -req -CA ca.crt -CAkey ca.key -CAcreateserial -in client.csr
 -out client.crt
var tls = require('tls');
var fs = require('fs');


# HTTPS

### HTTPS服务端

需要上文生成的私钥和签名证书

var https = require('https');
var fs = require('fs');

### HTTPS客户端

```javascript
var https = require('https');
var fs = require('fs');
var options = {
hostname: 'localhost',
port: 8000,
path: '/',
method: 'GET',
key: fs.readFileSync('./keys/client.key'),
cert: fs.readFileSync('./keys/client.crt'),
ca: [fs.readFileSync('./keys/ca.crt')]
};
options.agent = new https.Agent(options);
var req = https.request(options, function(res) {
res.setEncoding('utf-8');var https = require('https');
var fs = require('fs');
var options = {
hostname: 'localhost',
port: 8000,
path: '/',
method: 'GET',
key: fs.readFileSync('./keys/client.key'),
cert: fs.readFileSync('./keys/client.crt'),
ca: [fs.readFileSync('./keys/ca.crt')]
};
options.agent = new https.Agent(options);
var req = https.request(options, function(res) {
res.setEncoding('utf-8');
res.on('data', function(d) {
console.log(d);
});
});
req.end();
req.on('error', function(e) {
console.log(e);
});
```